﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;
using DocumentFormat.OpenXml.Packaging;
using OpenXmlPowerTools;

class Program
{
    static void Main(string[] args)
    {
        var deleteList = Directory.GetFiles("../../", "Updated-*.docx");
        foreach (var df in deleteList)
        {
            FileInfo dfi = new FileInfo(df);
            dfi.Delete();
        }

        deleteList = Directory.GetFiles("../../", "Updated-*.pptx");
        foreach (var df in deleteList)
        {
            FileInfo dfi = new FileInfo(df);
            dfi.Delete();
        }

        var fileList = Directory.GetFiles("../../", "*.docx");
        foreach (var file in fileList)
        {
            var fi = new FileInfo(file);
            Console.WriteLine(fi.Name);
            var newFileName = "../../Updated-" + fi.Name;
            var fi2 = new FileInfo(newFileName);
            if (fi2.Exists)
                fi2.Delete();
            File.Copy(fi.FullName, fi2.FullName);

            using (var wDoc = WordprocessingDocument.Open(fi2.FullName, true))
            {
                var chart1Data = new ChartData
                {
                    SeriesNames = new [] {
                        "Car",
                        "Truck",
                        "Van",
                    },
                    CategoryNames = new [] {
                        "Q1",
                        "Q2",
                        "Q3",
                        "Q4",
                    },
                    Values = new double[][] {
                        new double[] {
                            320, 310, 320, 330,
                        },
                        new double[] {
                            201, 224, 230, 221,
                        },
                        new double[] {
                            180, 200, 220, 230,
                        },
                    },
                };
                ChartUpdater.UpdateChart(wDoc, "Chart1", chart1Data);

                var chart2Data = new ChartData
                {
                    SeriesNames = new[] {
                        "Series"
                    },
                    CategoryNames = new[] {
                        "Cars",
                        "Trucks",
                        "Vans",
                        "Boats",
                    },
                    Values = new double[][] {
                        new double[] {
                            320, 112, 64, 80,
                        },
                    },
                };
                ChartUpdater.UpdateChart(wDoc, "Chart2", chart2Data);

                var chart3Data = new ChartData
                {
                    SeriesNames = new[] {
                        "X1",
                        "X2",
                        "X3",
                        "X4",
                        "X5",
                        "X6",
                    },
                    CategoryNames = new[] {
                        "Y1",
                        "Y2",
                        "Y3",
                        "Y4",
                        "Y5",
                        "Y6",
                    },
                    Values = new double[][] {
                        new double[] {      3.0,      2.1,       .7,      .7,      2.1,      3.0,      },
                        new double[] {      3.0,      2.1,       .8,      .8,      2.1,      3.0,      },
                        new double[] {      3.0,      2.4,      1.2,     1.2,      2.4,      3.0,      },
                        new double[] {      3.0,      2.7,      1.7,     1.7,      2.7,      3.0,      },
                        new double[] {      3.0,      2.9,      2.5,     2.5,      2.9,      3.0,      },
                        new double[] {      3.0,      3.0,      3.0,     3.0,      3.0,      3.0,      },
                    },
                };
                ChartUpdater.UpdateChart(wDoc, "Chart3", chart3Data);

                var chart4Data = new ChartData
                {
                    SeriesNames = new[] {
                        "Car",
                        "Truck",
                        "Van",
                    },
                    CategoryNames = new[] {
                        ToExcelInteger(new DateTime(2013, 9, 1)),
                        ToExcelInteger(new DateTime(2013, 9, 2)),
                        ToExcelInteger(new DateTime(2013, 9, 3)),
                        ToExcelInteger(new DateTime(2013, 9, 4)),
                        ToExcelInteger(new DateTime(2013, 9, 5)),
                        ToExcelInteger(new DateTime(2013, 9, 6)),
                        ToExcelInteger(new DateTime(2013, 9, 7)),
                        ToExcelInteger(new DateTime(2013, 9, 8)),
                        ToExcelInteger(new DateTime(2013, 9, 9)),
                        ToExcelInteger(new DateTime(2013, 9, 10)),
                        ToExcelInteger(new DateTime(2013, 9, 11)),
                        ToExcelInteger(new DateTime(2013, 9, 12)),
                        ToExcelInteger(new DateTime(2013, 9, 13)),
                        ToExcelInteger(new DateTime(2013, 9, 14)),
                        ToExcelInteger(new DateTime(2013, 9, 15)),
                        ToExcelInteger(new DateTime(2013, 9, 16)),
                        ToExcelInteger(new DateTime(2013, 9, 17)),
                        ToExcelInteger(new DateTime(2013, 9, 18)),
                        ToExcelInteger(new DateTime(2013, 9, 19)),
                        ToExcelInteger(new DateTime(2013, 9, 20)),
                    },
                    Values = new double[][] {
                        new double[] {
                            1, 2, 3, 2, 3, 4, 5, 4, 5, 6, 5, 4, 5, 6, 7, 8, 7, 8, 8, 9,
                        },
                        new double[] {
                            2, 3, 3, 4, 4, 5, 6, 7, 8, 7, 8, 9, 9, 9, 7, 8, 9, 9, 10, 11,
                        },
                        new double[] {
                            2, 3, 3, 3, 3, 2, 2, 2, 3, 2, 3, 3, 4, 4, 4, 3, 4, 5, 5, 4,
                        },
                    },
                };
                ChartUpdater.UpdateChart(wDoc, "Chart4", chart4Data);

            }
        }

        fileList = Directory.GetFiles("../../", "*.pptx");
        foreach (var file in fileList)
        {
            var fi = new FileInfo(file);
            Console.WriteLine(fi.Name);
            var newFileName = "../../Updated-" + fi.Name;
            var fi2 = new FileInfo(newFileName);
            if (fi2.Exists)
                fi2.Delete();
            File.Copy(fi.FullName, fi2.FullName);

            using (var pDoc = PresentationDocument.Open(fi2.FullName, true))
            {
                var chart1Data = new ChartData
                {
                    SeriesNames = new[] {
                        "Car",
                        "Truck",
                        "Van",
                    },
                    CategoryNames = new[] {
                        "Q1",
                        "Q2",
                        "Q3",
                        "Q4",
                    },
                    Values = new double[][] {
                        new double[] {
                            320, 310, 320, 330,
                        },
                        new double[] {
                            201, 224, 230, 221,
                        },
                        new double[] {
                            180, 200, 220, 230,
                        },
                    },
                };
                ChartUpdater.UpdateChart(pDoc, 1, chart1Data);
            }
        }

        Console.WriteLine("Press Enter");
        Console.ReadKey();
    }

    private static string ToExcelInteger(DateTime dateTime)
    {
        var str = ((dateTime - new DateTime(1900, 1, 1)).TotalDays + 2).ToString();
        return str;
    }
}

public class ChartData
{
    public string[] SeriesNames;
    public string[] CategoryNames;
    public double[][] Values;
}

public class ChartUpdater
{
    public static bool UpdateChart(WordprocessingDocument wDoc, string contentControlTag, ChartData chartData)
    {
        var mainDocumentPart = wDoc.MainDocumentPart;
        var mdXDoc = mainDocumentPart.GetXDocument();
        var cc = mdXDoc.Descendants(W.sdt)
            .FirstOrDefault(sdt => (string)sdt.Elements(W.sdtPr).Elements(W.tag).Attributes(W.val).FirstOrDefault() == contentControlTag);
        if (cc != null)
        {
            var chartRid = (string)cc.Descendants(C.chart).Attributes(R.id).FirstOrDefault();
            if (chartRid != null)
            {
                ChartPart chartPart = (ChartPart)mainDocumentPart.GetPartById(chartRid);
                UpdateChart(chartPart, chartData);
                var newContent = cc.Elements(W.sdtContent).Elements().Select(e => new XElement(e));
                cc.ReplaceWith(newContent);
                mainDocumentPart.PutXDocument();
                return true;
            }
        }
        return false;
    }

    private static void UpdateChart(ChartPart chartPart, ChartData chartData)
    {
        if (chartData.Values.Length != chartData.SeriesNames.Length)
            throw new ArgumentException("Invalid chart data");
        foreach (var ser in chartData.Values)
        {
            if (ser.Length != chartData.CategoryNames.Length)
                throw new ArgumentException("Invalid chart data");
        }

        UnlinkSpreadsheet(chartPart);
        UpdateSeries(chartPart, chartData);
    }

    private static void UnlinkSpreadsheet(ChartPart chartPart)
    {
        XDocument cpx = chartPart.GetXDocument();
        XElement newRoot = (XElement)UnlinkSpreadsheetTransform(cpx.Root);
        cpx.Root.ReplaceWith(newRoot);
        chartPart.PutXDocument();
        var workbookPartPair = chartPart.Parts.FirstOrDefault(p => p.OpenXmlPart.ContentType == "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
        if (workbookPartPair != null)
            chartPart.DeletePart(workbookPartPair.OpenXmlPart);
    }

    private static void UpdateSeries(ChartPart chartPart, ChartData chartData)
    {
        XDocument cpXDoc = chartPart.GetXDocument();
        XElement root = cpXDoc.Root;
        var firstSeries = root.Descendants(C.ser).FirstOrDefault();
        var numLit = firstSeries.Elements(C.val).Elements(C.numLit).FirstOrDefault();

        // remove all but first series
        firstSeries.Parent.Elements(C.ser).Skip(1).Remove();

        var newSetOfSeries = chartData.SeriesNames
            .Select((string sn, int si) =>
            {
                XElement cat = null;

                if (firstSeries.Elements(C.cat).Elements(C.numLit).Any())
                {
                    cat = new XElement(C.cat,
                        new XElement(C.numLit,
                            firstSeries.Elements(C.cat).Elements(C.numLit).Elements(C.formatCode),
                            new XElement(C.ptCount, new XAttribute("val", chartData.CategoryNames.Length)),
                            chartData.CategoryNames.Select((string cn, int ci) =>
                            {
                                var newPt = new XElement(C.pt,
                                    new XAttribute("idx", ci),
                                    new XElement(C.v, 
                                        Int32.Parse(chartData.CategoryNames[ci]).ToString()));  // convert to int and back to string
                                                       // to make sure that the cat names are integer values, i.e. dates
                                return newPt;
                            })));
                }
                else
                {
                    cat = new XElement(C.cat,
                        new XElement(C.strLit,
                            new XElement(C.ptCount, new XAttribute("val", chartData.CategoryNames.Length)),
                            chartData.CategoryNames.Select((string cn, int ci) =>
                            {
                                var newPt = new XElement(C.pt,
                                    new XAttribute("idx", ci),
                                    new XElement(C.v, chartData.CategoryNames[ci]));
                                return newPt;
                            })));
                }

                var newSer = new XElement(C.ser,
                    new XElement(C.idx, new XAttribute("val", si)),
                    new XElement(C.order, new XAttribute("val", si)),
                    new XElement(C.tx,
                        new XElement(C.v, sn)),
                    firstSeries.Elements().Where(e => e.Name == C.spPr),
                    cat,
                    new XElement(C.val,
                        new XElement(C.numLit,
                            numLit.Elements(C.formatCode),
                            new XElement(C.ptCount, new XAttribute("val", chartData.CategoryNames.Length)),
                            chartData.CategoryNames.Select((string cn, int ci) =>
                            {
                                var newPt = new XElement(C.pt,
                                    new XAttribute("idx", ci),
                                    new XElement(C.v, chartData.Values[si][ci]));
                                return newPt;
                            }))),
                    firstSeries.Elements().Where(e => e.Name != C.idx &&
                        e.Name != C.order &&
                        e.Name != C.tx &&
                        e.Name != C.cat &&
                        e.Name != C.val &&
                        e.Name != C.spPr)
                );
                int accentNumber = (si % 6) + 1;
                newSer = (XElement)UpdateAccentTransform(newSer, accentNumber);
                return newSer;
            });
        firstSeries.ReplaceWith(newSetOfSeries);
        chartPart.PutXDocument();
    }

    private static object UpdateAccentTransform(XNode node, int accentNumber)
    {
        XElement element = node as XElement;
        if (element != null)
        {
            if (element.Name == A.schemeClr && (string)element.Attribute("val") == "accent1")
                return new XElement(A.schemeClr, new XAttribute("val", "accent" + accentNumber));

            return new XElement(element.Name,
                element.Attributes(),
                element.Nodes().Select(n => UpdateAccentTransform(n, accentNumber)));
        }
        return node;
    }

    private static object UnlinkSpreadsheetTransform(XNode node)
    {
        XElement element = node as XElement;
        if (element != null)
        {
            if (element.Name == C.externalData)
                return null;

            if (element.Name == C.numFmt)
                return new XElement(element.Name,
                    element.Attribute("formatCode"));

            if (element.Name == C.numRef)
                return new XElement(C.numLit,
                    element.Elements(C.numCache).Elements());

            if (element.Name == C.strRef)
                return new XElement(C.strLit,
                    element.Elements(C.strCache).Elements());

            if (element.Name == C.tx && element.Parent.Name == C.ser)
                return new XElement(C.tx, element.Descendants(C.v));

            return new XElement(element.Name,
                element.Attributes(),
                element.Nodes().Select(n => UnlinkSpreadsheetTransform(n)));
        }
        return node;
    }

    internal static bool UpdateChart(PresentationDocument pDoc, int slideNumber, ChartData chartData)
    {
        var presentationPart = pDoc.PresentationPart;
        var pXDoc = presentationPart.GetXDocument();
        var sldIdElement = pXDoc.Root.Elements(P.sldIdLst).Elements(P.sldId).Skip(slideNumber - 1).FirstOrDefault();
        if (sldIdElement != null)
        {
            var rId = (string)sldIdElement.Attribute(R.id);
            var slidePart = presentationPart.GetPartById(rId);
            var sXDoc = slidePart.GetXDocument();
            var chartRid = (string)sXDoc.Descendants(C.chart).Attributes(R.id).FirstOrDefault();
            if (chartRid != null)
            {
                ChartPart chartPart = (ChartPart)slidePart.GetPartById(chartRid);
                UpdateChart(chartPart, chartData);
                return true;
            }
            return true;
        }
        return false;
    }
}